
/*********************************************************************
 * Our special kind of string pointer
 */

typedef struct {
	const char	*b;
	const char	*e;
} txt;

#define PT(txt) (txt).e - (txt).b, (txt).b

static inline txt
Txt(const char *b, const char *e)
{
	txt s;

	s.b = b;
	if (e == NULL) {
		s.e = strchr(b, '\0');
		assert(s.e != NULL);
	} else {
		s.e = e;
	}
	return (s);
}

static inline unsigned
TxtLen(txt s1)
{

	assert(s1.e >= s1.b);
	return (unsigned)(s1.e - s1.b);
}

/* Check txt identity */
static inline int
TxtIdent(txt s1, txt s2)
{

	return (s1.b == s2.b && s1.e == s2.e);
}

/* Check txt equality */
static inline unsigned int
TxtEq(txt s1, txt s2)
{

	if (TxtIdent(s1, s2))
		return (1);
	if (TxtLen(s1) != TxtLen(s2))
		return (0);
	return (!memcmp(s1.b, s2.b, TxtLen(s1)));
}

#define TxtIs(txt, cnst) \
	(TxtLen(txt) == sizeof(cnst) - 1 && !memcmp(txt.b, cnst, sizeof(cnst) -1))

