/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: defs.h,v 1.8 2005/10/31 08:01:11 phk Exp $
 *
 */

#include <stdio.h>
#include <sys/queue.h>

struct info {
	TAILQ_ENTRY(info)	list;
	char			*label;
	char			*contents;
};

TAILQ_HEAD(infolist, info);

#define YY_NO_UNPUT

int yyparse(void);
int yylex(void);
int yywrap(void);
void yyerror(const char *fmt, ...);

struct info *new_info(const char *label, const char *contents);
struct infolist *new_infolist(void);
void append_infolist(struct infolist *, const char *label, const char *contents);
const char *emit_enum(struct infolist *list);
const char *emit_word(const char *id, struct infolist *type_list, struct infolist *list);
const char *emit_instance(const char *id, const char *type, struct infolist *list);
const char *emit_extern(const char *id, const char *ref, struct infolist *list);
const char *emit_node(const char *id, struct infolist *list);
const char *emit_import(const char *id, struct infolist *list);

extern int lineno;
