/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: instance.c,v 1.10 2007/02/21 12:27:41 phk Exp $
 *
 * Conveniecce functions for users
 *
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "configkit.h"
#include "configkit_int.h"

int
__ck_walk_word(CK_ARG, struct ck_instancehead *ciph, struct __ck_node **nodes)
{
	struct ck_instance *cip;
	char *p;
	unsigned u;
	void *priv;

	if (cfa->flag & CK_HELP) {
		ck_printf(CK_PASS, "Specify instance word: {");
		TAILQ_FOREACH(cip, ciph, next)
			ck_printf(CK_PASS, " %s", cip->idx.word);
		ck_printf(CK_PASS, "}\n");
		return (0);
	}
	p = cfa->tree;
	priv = cfa->priv;
	TAILQ_FOREACH(cip, ciph, next) {
		if (cip->parent != priv)
			continue;
		cfa->priv = cip->obj;
		asprintf(&cfa->tree, "%s %s", p, cip->idx.word);
		u = cfa->output_happened;
		__ck_follow(cfa, nodes);
		if (u == cfa->output_happened && (cfa->flag & CK_CONF))
			ck_printf(CK_PASS, "%s\n", cfa->tree);
		free(cfa->tree);
	}
	cfa->tree = p;
	cfa->priv = priv;
        return (0);
}

int
__ck_walk_uint(CK_ARG, struct ck_instancehead *ciph, struct __ck_node **nodes)
{
	struct ck_instance *cip;
	char *p;
	unsigned u;
	void *priv;

	if (cfa->flag & CK_HELP) {
		ck_printf(CK_PASS, "Specify instance number: {");
		TAILQ_FOREACH(cip, ciph, next)
			ck_printf(CK_PASS, " %u", cip->idx.uint);
		ck_printf(CK_PASS, "}\n");
		return (0);
	}
	p = cfa->tree;
	priv = cfa->priv;
	TAILQ_FOREACH(cip, ciph, next) {
		if (cip->parent != priv)
			continue;
			
		cfa->priv = cip->obj;
		asprintf(&cfa->tree, "%s %u", p, cip->idx.uint);
		u = cfa->output_happened;
		__ck_follow(cfa, nodes);
		if (u == cfa->output_happened && (cfa->flag & CK_CONF))
			ck_printf(CK_PASS, "%s\n", cfa->tree);
		free(cfa->tree);
	}
	cfa->tree = p;
	cfa->priv = priv;
        return (0);
}

